SystemOrganization addCategory: #'TP BichOS'!

Object subclass: #Alimento
	instanceVariableNames: 'masa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Alimento methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 16:24'!
extraerAlimento
	| masaExtraida |
	masaExtraida := (10 min: (masa - 1)).
	masa := masa - (masaExtraida + 1).
	^ 0 max: masaExtraida. ! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa
	^ masa! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa: anObject
	masa := anObject! !

Object subclass: #Cansada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 16:37'!
descansar: unaHormiga
	unaHormiga estado: normal! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 20:58'!
llevarAlimentoA: unHormiguero con: unaHormiga! !

Object subclass: #Exaltada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

Object subclass: #Hormiga
	instanceVariableNames: 'pesollevado distanciaRecorrida posicion puntosRecorridos estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:40'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:41'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:45'!
distanciaRecorridaPromedio
	^ distanciaRecorrida / (puntosRecorridos length)! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:25'!
estaAlLimite
	^ pesollevado > 8! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 15:32'!
extraerComidaDe: unAlimento
	self posicion: unAlimento posicion.
	self pesollevado: unAlimento extraerComida! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:41'!
initialize
	distanciaRecorrida := 0.
	self pesollevado: 0.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:43'!
irA: unPunto
	self distanciaRecorrida: (distanciaRecorrida + posicion distanciaA: unPunto).
	self posicion: unPunto.
	puntosRecorridos add: unPunto.! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:46'!
latitud
	^ latitud! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:46'!
latitud: anObject
	latitud := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:51'!
llevarAlimentoA: unHormiguero
	unHormiguero aumentarDeposito: self alimentoRecolectado.
	self pesollevado: 0.
	self posicion: unHormiguero posicion ! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:46'!
longitud
	^ longitud! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:46'!
longitud: anObject
	longitud := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:16'!
pesollevado
	^ pesollevado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:16'!
pesollevado: anObject
	pesollevado := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion
	^ posicion! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion: anObject
	posicion := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos
	^ puntosRecorridos! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos: anObject
	puntosRecorridos := anObject! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigas deposito posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:23'!
alimentoRecolectado
	^ hormigas sum: [: hormiga | hormiga pesollevado]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:37'!
alimentoTotal
	^ deposito + self alimentoRecolectado! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:51'!
aumentarDeposito: unaCantidad
	self deposito: deposito + unaCantidad ! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:20'!
cantidadDeHormigas
	^ hormigas length! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas
	^ hormigas! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas: anObject
	hormigas := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:25'!
hormigasAlLimite
	^ (hormigas select: [: hormiga | hormiga estaAlLimite]) length! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion
	^ posicion! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion: anObject
	posicion := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:50'!
reclamarAlimento
	hormigas do: [: hormiga | hormiga llevarAlimentoA: self].! !

Object subclass: #Normal
	instanceVariableNames: 'exaltada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 16:40'!
descansar: unaHormiga
	unaHormiga estado: exaltada
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 20:58'!
llevarAlimentoA: unHormiguero con: unaHormiga
	unHormiguero aumentarDeposito: unaHormiga alimentoRecolectado.
	unaHormiga pesollevado: 0.
	unaHormiga posicion: unHormiguero posicion ! !

Object subclass: #Punto
	instanceVariableNames: 'latitud longitud'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Punto methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:08'!
distanciaA: otroPunto
	^ ((latitud - otroPunto latitud) ** 2 + (longitud - otroPunto longitud) ** 2) sqrt! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud
	^ latitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud: anObject
	latitud := anObject! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud
	^ longitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud: anObject
	longitud := anObject! !
